/**
	Examples for gil library from  https://www.cmlab.csie.ntu.edu.tw/trac/libgil2/wiki
	Detail please refer to the website's user manual
*/
#include <stdio.h>

#include <gil/gil.h>
using namespace gil;


int main(void)
{
	// Variable for storing image
	FloatImage3 img1;
	FloatImage3 img2;
	FloatImage3 img3;
	FloatImage3 img4;
	FloatImage3 img5;

	// Read in the image
	read(img1,"s7708_01.bmp");
	read(img2,"s7708_02.bmp");
	read(img3,"s7708_03.bmp");
	read(img4,"s7708_04.bmp");
	read(img5,"s7708_05.bmp");

	FloatImage3 result(img1.width(), img2.height());
	result.fill(Float3(0, 0, 0));

	for(int i = 0; i < img1.width(); i++){
		for(int j = 0; j < img1.height(); j++){
			for(int k = 0; k < 3; k++){
				result(i, j)[k] = 0.2 * (img1(i, j)[k] +img2(i, j)[k]+img3(i, j)[k]+img4(i, j)[k]+img5(i, j)[k]);
			}
		}
	}



	// Example of usage from the web site
	// FloatImage3 a(100, 200); // a is 100x200
	// a.fill( Float3(0, 0, 0) ); // fill a with (0, 0, 0)
	// a.width(); // 100
	// a.height(); // 200
	// a.channels(); // 3
	// a.size(); // 100*200 = 20000
	// a(10, 20); // the pixel of the position (10, 20)
	// a(10, 20)[2]; // the third channel of the pixel of position (10, 20)
	// ByteImage3 b(200, 300);
	// b = a; // assign a to b, b is 100x200 now (b is re-allocated).
	// ByteImage3 c(200, 300);
	// c.replace(a); // replace the region (0, 0)-(100, 200) of c with a;


	// Write out the image
	write(result, "result.hdr");
	printf("Hello world\n");
	getchar();
}